



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[转] SSH原理与运用（2）：远程操作与端口转发</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[转] SSH原理与运用（2）：远程操作与端口转发</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 21:42:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>英文：阮一峰<br />
链接：<a href="http://www.ruanyifeng.com/blog/2011/12/ssh_port_forwarding.html" rel="external nofollow noreferrer">http://www.ruanyifeng.com/blog/2011/12/ssh_port_forwarding.html</a></p>
<p>接着前一次的文章，继续介绍SSH的用法。</p>
<p>（Image credit: Tony Narlock）</p>
<p>七、远程操作</p>
<p>SSH不仅可以用于远程主机登录，还可以直接在远程主机上执行操作。</p>
<p>上一节的操作，就是一个例子：</p>
<p>$ ssh <a href="user@host" rel="external nofollow noreferrer">user@host</a> ‘mkdir -p .ssh &amp;&amp; cat &gt;&gt; .ssh/authorized_keys’ &lt; ~/.ssh/id_rsa.pub</p>
<p>单引号中间的部分，表示在远程主机上执行的操作；后面的输入重定向，表示数据通过SSH传向远程主机。</p>
<p>这就是说，SSH可以在用户和远程主机之间，建立命令和数据的传输通道，因此很多事情都可以通过SSH来完成。</p>
<p>下面看几个例子。</p>
<p>【例1】<br />
将$HOME/src/目录下面的所有文件，复制到远程主机的$HOME/src/目录。</p>
<p>$ cd &amp;&amp; tar czv src | ssh <a href="user@host" rel="external nofollow noreferrer">user@host</a> ‘tar xz’</p>
<p>【例2】<br />
将远程主机$HOME/src/目录下面的所有文件，复制到用户的当前目录。</p>
<p>$ ssh <a href="user@host" rel="external nofollow noreferrer">user@host</a> ‘tar cz src’ | tar xzv</p>
<p>【例3】<br />
查看远程主机是否运行进程httpd。</p>
<p>$ ssh <a href="user@host" rel="external nofollow noreferrer">user@host</a> ‘ps ax | grep [h]ttpd’</p>
<p>八、绑定本地端口</p>
<p>既然SSH可以传送数据，那么我们可以让那些不加密的网络连接，全部改走SSH连接，从而提高安全性。</p>
<p>假定我们要让8080端口的数据，都通过SSH传向远程主机，命令就这样写：</p>
<p>$ ssh -D 8080 <a href="user@host" rel="external nofollow noreferrer">user@host</a></p>
<p>SSH会建立一个socket，去监听本地的8080端口。一旦有数据传向那个端口，就自动把它转移到SSH连接上面，发往远程主机。可以想象，如果8080端口原来是一个不加密端口，现在将变成一个加密端口。</p>
<p>九、本地端口转发</p>
<p>有时，绑定本地端口还不够，还必须指定数据传送的目标主机，从而形成点对点的”端口转发”。为了区别后文的”远程端口转发”，我们把这种情况称为”本地端口转发”（Local forwarding）。</p>
<p>假定host1是本地主机，host2是远程主机。由于种种原因，这两台主机之间无法连通。但是，另外还有一台host3，可以同时连通前面两台主机。因此，很自然的想法就是，通过host3，将host1连上host2。</p>
<p>我们在host1执行下面的命令：</p>
<p>$ ssh -L 2121:host2:21 host3</p>
<p>命令中的L参数一共接受三个值，分别是”本地端口:目标主机:目标主机端口”，它们之间用冒号分隔。这条命令的意思，就是指定SSH绑定本地端口2121，然后指定host3将所有的数据，转发到目标主机host2的21端口（假定host2运行FTP，默认端口为21）。</p>
<p>这样一来，我们只要连接host1的2121端口，就等于连上了host2的21端口。</p>
<p>$ ftp localhost:2121</p>
<p>“本地端口转发”使得host1和host3之间仿佛形成一个数据传输的秘密隧道，因此又被称为”SSH隧道”。</p>
<p>下面是一个比较有趣的例子。</p>
<p>$ ssh -L 5900:localhost:5900 host3</p>
<p>它表示将本机的5900端口绑定host3的5900端口（这里的localhost指的是host3，因为目标主机是相对host3而言的）。</p>
<p>另一个例子是通过host3的端口转发，ssh登录host2。</p>
<p>$ ssh -L 9001:host2:22 host3</p>
<p>这时，只要ssh登录本机的9001端口，就相当于登录host2了。</p>
<p>$ ssh -p 9001 localhost</p>
<p>上面的-p参数表示指定登录端口。</p>
<p>十、远程端口转发</p>
<p>既然”本地端口转发”是指绑定本地端口的转发，那么”远程端口转发”（remote forwarding）当然是指绑定远程端口的转发。</p>
<p>还是接着看上面那个例子，host1与host2之间无法连通，必须借助host3转发。但是，特殊情况出现了，host3是一台内网机器，它可以连接外网的host1，但是反过来就不行，外网的host1连不上内网的host3。这时，”本地端口转发”就不能用了，怎么办？</p>
<p>解决办法是，既然host3可以连host1，那么就从host3上建立与host1的SSH连接，然后在host1上使用这条连接就可以了。</p>
<p>我们在host3执行下面的命令：</p>
<p>$ ssh -R 2121:host2:21 host1</p>
<p>R参数也是接受三个值，分别是”远程主机端口:目标主机:目标主机端口”。这条命令的意思，就是让host1监听它自己的2121端口，然后将所有数据经由host3，转发到host2的21端口。由于对于host3来说，host1是远程主机，所以这种情况就被称为”远程端口绑定”。</p>
<p>绑定之后，我们在host1就可以连接host2了：</p>
<p>$ ftp localhost:2121</p>
<p>这里必须指出，”远程端口转发”的前提条件是，host1和host3两台主机都有sshD和ssh客户端。</p>
<p>十一、SSH的其他参数</p>
<p>SSH还有一些别的参数，也值得介绍。</p>
<p>N参数，表示只连接远程主机，不打开远程shell；T参数，表示不为这个连接分配TTY。这个两个参数可以放在一起用，代表这个SSH连接只用来传数据，不执行远程操作。</p>
<p>$ ssh -NT -D 8080 host</p>
<p>f参数，表示SSH连接成功后，转入后台运行。这样一来，你就可以在不中断SSH连接的情况下，在本地shell中执行其他操作。</p>
<p>$ ssh -f -D 8080 host</p>
<p>要关闭这个后台连接，就只有用kill命令去杀掉进程。</p>
<p>十二、参考文献</p>
<ul><li>SSH, The Secure Shell: The Definitive Guide: 2.4. Authentication by Cryptographic Key, O’reilly</li>
<li>SSH, The Secure Shell: The Definitive Guide: 9.2. Port Forwarding, O’reilly</li>
<li>Shebang: Tips for Remote Unix Work (SSH, screen, and VNC)</li>
<li>brihatch: SSH Host Key Protection</li>
<li>brihatch: SSH User Identities</li>
<li>IBM developerWorks: 实战 SSH 端口转发</li>
<li>Jianing YANG：ssh隧道技术简介</li>
<li>WikiBooks: Internet Technologies/SSH</li>
<li>Buddhika Chamith: SSH Tunneling Explained</li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j2ngl8.html">A - 迷宫问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkjxrq.html">Android Handler机制&lpar;四&rpar;---Handler源码解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/r935ddwq.html">Python Django 的 django templatedoesnotexist</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xxygr9.html">win 8  pip install 或者 pycharm 安装 paramiko 报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mexl1q.html">MySQL数据库获取汉字拼音的首字母函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmw1lk9.html">&lbrack;改善Java代码&rsqb;严格限定泛型类型采用多重界限</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdn02k8.html">edmbed system----ecos</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1gd0j9.html">【Java】Java8新增的Lambda表达式&lowbar;学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x42z09.html">Android Studio 实用快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmy3ge9.html">HBASE学习笔记--shell</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zngnj9.html">HTML入门第二天</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zd0eg9.html">使用Dubbo、JSF等RPC框架时，对于异常的处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojodl1q.html">python内建函数isinstance基础用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1pjwyq.html">linux 下 nc 命令的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me7e32q.html">Android ViewManager解读之requestLayout&lpar;&rpar; 详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yml4w8.html">java中的反射整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyd37j9.html">任意模数NTT学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2nrg2q.html">python glob模块使用笔记（更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rmlvo9.html">Python 解决命令行删除、退格乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wpgy0q.html">Syntax error&comma; parameterized types are only available if source level is 1&period;5 解决方案</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/3904ken8.html">C&sol;C&plus;&plus;头文件一览</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e3rrzq.html">Java学习笔记七&mdash;&mdash;数组工具类Arrays</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o3owe8.html">编译PHP5缺t1lib包安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e32dmq.html">String、String&period;valueOf、toString 它们三者的区别总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96lg6y9.html">linux-dns服务器搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p75x49.html">MQTT V3&period;1----flow</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlw0dk8.html">Javascript图表插件HighCharts用法案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1y6p2q.html">Java设计模式7：适配器模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwnmnlq.html">人人都是 DBA（II）SQL Server 元数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdg430q.html">dojo&sol;dom-style样式操作学习笔记</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
